<?php
/**
* Plugin Name: Car Demon
* Plugin URI: http://CarDemons.com/
* Description:  Car Demon is a PlugIn designed for car dealers and other vehicle sales.
* Author: CarDemons
* Version: 1.6.4
* Author URI: http://CarDemons.com/
* Text Domain: car-demon
* Domain Path: /languages
* License: GPL2
* WPCD ID: 101
*/

require_once( 'includes/cd-init.php' );
require_once( 'includes/car-demon-header.php' );
require_once( 'includes/car-demon-query.php' );
require_once( 'includes/create-post-types-tax.php' );
require_once( 'includes/cd-save.php' );
require_once( 'includes/cd-template-redirect.php' );
require_once( 'includes/register-sidebars.php');
require_once( 'includes/vehicle-price.php' );
require_once( 'includes/list-cars.php' );
require_once( 'includes/compare-vehicles.php' );
require_once( 'includes/get-contact-info.php' );
require_once( 'includes/user-control.php' );
require_once( 'includes/staff-pages.php' );
require_once( 'includes/dynamic-load.php' );
require_once( 'includes/cd-template.php' );
require_once( 'includes/shortcodes.php' );
require_once( 'includes/cd-comments.php' );
require_once( 'includes/suggested_required.php' );
require_once( 'includes/payment-calculator.php' );
require_once( 'search/search-form.php' );
require_once( 'search/search-fields.php' );
require_once( 'admin/cd-admin.php' );
require_once( 'widgets/calculator-widget.php' );
require_once( 'widgets/tag-cloud.php' );
require_once( 'widgets/random-cars.php' );
require_once( 'widgets/car-search-widget.php' );
require_once( 'widgets/compare-widget.php' );
require_once( 'widgets/vehicle-contact-widget.php' );
require_once( 'vin-query/vin-query.php' );
require_once( 'car-demon-forms/car-demon-forms.php' );
require_once( 'filters/crf.php' );
require_once( 'shortcode/cd-shortcode.php' );

//= Define the path to Car Demon
$car_demon_pluginpath = plugins_url() . '/car-demon/';
define( 'CAR_DEMON_PATH', $car_demon_pluginpath );

add_action( 'plugins_loaded', 'cardemon_language' );
function cardemon_language(){
    $domain = 'car-demon';
    // The "plugin_locale" filter is also used in load_plugin_textdomain()
    $locale = apply_filters( 'plugin_locale', get_locale(), $domain );

    load_plugin_textdomain( $domain, FALSE, dirname(plugin_basename(__FILE__)).'/languages/' );
}

register_activation_hook( __FILE__, 'car_crf_activate' );
function car_crf_activate() {
	$cd_cdrf_options = array();
	$cd_cdrf_options = get_option( 'car_demon_options' );
	$cd_cdrf_options['use_theme_files'] = 'No';
	$cd_cdrf_options['cd_cdrf_style'] = 'content-replacement';
	$cd_cdrf_options['cd_cdrf_page_style'] = 'content-replacement';
	$cd_cdrf_options['use_session'] = 'No';
	$cd_cdrf_options['drop_down_sort'] = 'Yes';
	update_option( 'car_demon_options', $cd_cdrf_options );
	set_transient( '_cd_welcome_screen_activation_redirect', true, 30 );
}

register_deactivation_hook( __FILE__, 'car_crf_deactivate' );
function car_crf_deactivate() {
	$cd_cdrf_options = array();
	$cd_cdrf_options = get_option( 'car_demon_options' );
	update_option( 'car_demon_options', $cd_cdrf_options );
}

/*
                        ______________
                __..=='|'   |         ``-._
   \=====_..--'/'''    |    |              ``-._
   |'''''      ```---..|____|_______________[)>.``-.._____
   |\_______.....__________|____________     ''  \      __````---.._
 ./'     /.-'_'_`-.\       |  ' '       ```````---|---/.-'_'_`=.-.__```-._
 |.__  .'/ /     \ \`.      \                     | .'/ /     \ \`. ```-- `.
  \  ``|| |   o   | ||-------\-------------------/--|| |   o   | ||--------|
   "`--' \ \ _ _ / / |______________________________| \ \ _ _ / / |..----```
          `-.....-'                                    `-.....-'
						https://CarDemons.com
                                            ,   ,
             ,    ,    /\   /\             /(   )\
            /( /\ )\  _\ \_/ /_            \ \_/ /   , /\ ,
            |\_||_/| < \_   _/ >           /_   _\  /| || |\
            \______/  \|X\"/X|/           | \> </ | |\_||_/|
              _\/_   _(_  ^  _)_          (_  ^  _)  \____/
             ( () ) /`\|V"""V|/`\       /`\|IIIII|/`\ _\/_
               {}   \  \__ __/  /       \  \_____/  /  ()
               ()   /\   )V(   /\       /\   )=(   /\  ()
               {}  /  \_/\=/\_/  \     /  `-.\=/.-'  \ ()

*/
?>