<?php
function car_demon_query_search($query=array()) {
	global $car_demon_options;
	$get = array_merge($_GET, $query);
	
	if (is_array($get)) {
		foreach ($get as $key=>$value) {
			if ($value == 'ALL') {
				$get[$key] = '';
			}
		}
	}

	if (isset($car_demon_options['cars_per_page'])) {
		$cars_per_page = $car_demon_options['cars_per_page'];
	} else {
		$cars_per_page = 9;
	}
	if (isset($get['cars_per_page'])) {
		$cars_per_page = $get['cars_per_page'];
	}

	if (isset($get['car'])) {
		add_filter( 'wp_title', 'car_demon_filter_search_title', 10, 3 );
		$order_by = '_price_value';
		$order_by_dir = 'ASC';
		if (isset($get['order_by'])) {
			$order_by = sanitize_text_field($get['order_by']);
		}
		if (isset($get['order_by_dir'])) {
			$order_by_dir = sanitize_text_field($get['order_by_dir']);
		}	
		$paged = get_query_var( 'paged' ) ? get_query_var( 'paged' ) : 1;

		if ($car_demon_options['show_sold'] != 'Yes') {
			$meta_query = array(
				array(
					'key' => 'sold',
					'value' => 'no',
					'compare' => '='
				)
			);
		} else {
			$meta_query = array();
		}
		if (isset($get['stock'])) {
			if ($get['stock']) {
				$stock = sanitize_text_field($get['stock']);
				$meta_query = array_merge($meta_query, array(array('key' => '_stock_value','value' => $stock, 'compare' => '=', 'type' => 'text')));
			}
		}
		if (isset($get['search_dropdown_miles'])) {
			if ($get['search_dropdown_miles']) {
				$miles = sanitize_text_field($get['search_dropdown_miles']);
				$meta_query = array_merge($meta_query, array(array('key' => '_mileage_value','value' => $miles, 'compare' => '<', 'type' => 'numeric')));
			}
		}
		if (isset($get['search_transmission'])) {
			$get['search_dropdown_tran'] = $get['search_transmission'];
		}
		if (isset($get['search_dropdown_tran'])) {
			if ($get['search_dropdown_tran']) {
				$trans = sanitize_text_field($get['search_dropdown_tran']);
				$meta_query = array_merge($meta_query, array(array('key' => '_transmission_value','value' => $trans, 'compare' => '=', 'type' => 'text')));
			}
		}
		
		if (isset($get['search_dropdown_Min_price'])) {
			$min_price = sanitize_text_field($get['search_dropdown_Min_price']);
		} else {
			$min_price = '';
		}
		if (isset($get['search_dropdown_Max_price'])) {
			$max_price = sanitize_text_field($get['search_dropdown_Max_price']);
		} else {
			$max_price = '';
		}
		
		if ($max_price > 0) {
			if ($min_price == 0) { $min_price = -1; }
			$meta_query = array_merge($meta_query, array(array('key' => '_price_value','value' => array( $min_price, $max_price ), 'compare' => 'BETWEEN', 'type' => 'numeric')));
		} else {
			if ($min_price > 0) {
				$meta_query = array_merge($meta_query, array(array('key' => '_price_value','value' => $min_price, 'compare' => '>', 'type' => 'numeric')));
			}
		}

		if (isset($get['search_dropdown_miles_Min'])) {
			$min_mileage = sanitize_text_field($get['search_dropdown_miles_Min'])-1;
		} else {
			$min_mileage = '';
		}
		if (isset($get['search_dropdown_miles_Max'])) {
			$max_mileage = sanitize_text_field($get['search_dropdown_miles_Max'])+1;
		} else {
			$max_mileage = '';
		}
		
		if ($max_mileage > 0) {
			if ($min_mileage == 0) { $min_mileage = 1; }
			$meta_query = array_merge($meta_query, array(array('key' => '_mileage_value','value' => array( $min_mileage, $max_mileage ), 'compare' => 'BETWEEN', 'type' => 'numeric')));
		} else {
			if ($min_mileage > 0) {
				$meta_query = array_merge($meta_query, array(array('key' => '_mileage_value','value' => $min_mileage, 'compare' => '>', 'type' => 'numeric')));
			}
		}

		// Search decode field
		if (isset($get['criteria'])) {
			$criteria = sanitize_text_field($get['criteria']);
			if ($criteria) {
				if (strpos($criteria, ',')) {
					$criteria_array = explode(',', $criteria);
					foreach($criteria_array as $search_criteria) {
						$meta_query = array_merge($meta_query, array(array('key' => 'decode_string','value' => $search_criteria, 'compare' => 'LIKE', 'type' => 'text')));
					}
				} else {
					$meta_query = array_merge($meta_query, array(array('key' => 'decode_string','value' => $criteria, 'compare' => 'LIKE', 'type' => 'text')));
				}
			}
		}
		if (isset($get['search_location'])) {
			$search_location = sanitize_text_field($get['search_location']);
			$my_query = array(
					'post_type' => 'cars_for_sale',
					'is_paged' => true,
					'paged' => $paged,
					'posts_per_page' => $cars_per_page,
					'meta_query' => $meta_query,
					'orderby' => 'meta_value_num',
					'meta_key' => $order_by,
					'order'    => $order_by_dir,
					'taxonomy' =>'vehicle_location',
					'term' => $search_location
				);
		} else {
			$my_query = array(
					'post_type' => 'cars_for_sale',
					'is_paged' => true,
					'paged' => $paged,
					'posts_per_page' => $cars_per_page,
					'meta_query' => $meta_query,
					'orderby' => 'meta_value_num',
					'meta_key' => $order_by,
					'order'    => $order_by_dir
				);
			$search_location = '';
		}
		$my_query = array(
				'post_type' => 'cars_for_sale',
				'is_paged' => true,
				'paged' => $paged,
				'posts_per_page' => $cars_per_page,
				'meta_query' => $meta_query,
				'orderby' => 'meta_value_num',
				'meta_key' => $order_by,
				'order'    => $order_by_dir,
				'taxonomy' =>'vehicle_location',
				'term' => $search_location
			);
			
			
			if (isset($get['search_dropdown_Min_years'])) {
				$min_year = sanitize_text_field($get['search_dropdown_Min_years']);
			} else {
				$min_year = '';
			}
			if (isset($get['search_dropdown_Max_years'])) {
				$max_year = sanitize_text_field($get['search_dropdown_Max_years']);
			} else {
				$max_year = '';
			}
			
			if ($max_year > 0) {
				if ($min_year == 0) { $min_year = 1984; }
				if (empty($min_year)) { $min_year = 1984; }
				$all_years = array();
				$number_of_years = $max_year - $min_year;
				$start_year = $min_year;
				while ($start_year < $max_year) {
					$all_years[] = $start_year;
					++$start_year;
				}
				$tax_query = array(
					'tax_query' => array(
						array(
							'taxonomy' => 'vehicle_year',
							'terms' => $all_years,
							'field' => 'slug',
							'compare' => 'BETWEEN',
							'type' => 'numeric'
						)
					));
				$my_query = array_merge($my_query, $tax_query);
			}
			
			if (isset($get['search_year'])) {
				if ($get['search_year']) {
					$search_year = sanitize_text_field($get['search_year']);
					$my_query = array_merge ($my_query, array('vehicle_year' => $search_year));
				}
			}
			if (isset($get['search_condition'])) {
				if ($get['search_condition']) {
					$search_condition = sanitize_text_field($get['search_condition']);
					$my_query = array_merge ($my_query, array('vehicle_condition' => $search_condition));
				}
			}
			if (isset($get['search_make'])) {
				if ($get['search_make']) {
					$search_make = sanitize_text_field($get['search_make']);
					$my_query = array_merge ($my_query, array('vehicle_make' => $search_make));
				}
			}
			if (isset($get['search_model'])) {
				if ($get['search_model']) {
					$search_model = sanitize_text_field($get['search_model']);
					$my_query = array_merge ($my_query, array('vehicle_model' => $search_model));
				}
			}
			if (isset($get['search_body_style'])) {
				$get['search_dropdown_body'] = $get['search_body_style'];				
			}
			if (isset($get['search_dropdown_body'])) {
				if ($get['search_dropdown_body']) {
					$search_dropdown_body = sanitize_text_field($get['search_dropdown_body']);
					$my_query = array_merge ($my_query, array('vehicle_body_style' => $search_dropdown_body));
				}
			}
		$my_query = apply_filters('car_demon_query_filter', $my_query );
		/*
		// for debug
		echo '<pre>';
			print_r($my_query);
		echo '</pre>';
		*/
		return $my_query;
	}
}

function car_demon_query_archive() {
	global $car_demon_options;
	global $query_string;
	if (isset($car_demon_options['cars_per_page'])) {
		$cars_per_page = $car_demon_options['cars_per_page'];
	} else {
		$cars_per_page = 9;
	}
	$order_by = '_price_value';
	$order_by_dir = 'ASC';
	if (isset($_GET['order_by'])) {
		$order_by = sanitize_text_field($_GET['order_by']);
	} else {
		$order_by = '';
	}
	if (isset($_GET['order_by_dir'])) {
		$order_by_dir = sanitize_text_field($_GET['order_by_dir']);
	} else {
		$order_by_dir = '';
	}
	$paged = get_query_var( 'paged' ) ? get_query_var( 'paged' ) : 1;
	if (isset($_GET['search_dropdown_Min_price'])) {
		$min_price = sanitize_text_field($_GET['search_dropdown_Min_price']);
	} else {
		$min_price = '';
	}
	if (isset($_GET['search_dropdown_Max_price'])) {
		$max_price = sanitize_text_field($_GET['search_dropdown_Max_price']);
	} else {
		$max_price = '';
	}
	if ($car_demon_options['show_sold'] != 'Yes') {
		$meta_query = array(
				array(
					'key' => 'sold',
					'value' => 'no',
					'compare' => '='
				)
			);
	}
	$my_query = array(
			'post_type' => 'cars_for_sale',
			'is_paged' => true,
			'paged' => $paged,
			'posts_per_page' => $cars_per_page,
			'meta_query' => $meta_query,
			'orderby' => 'meta_value_num',
			'meta_key' => $order_by,
			'order'    => $order_by_dir
		);
	$my_query = wp_parse_args( $query_string, $my_query );
	$my_query = apply_filters('car_demon_query_filter', $my_query );
	return $my_query;
}

function car_demon_sorting($page_type = 'search') {
	global $car_demon_options;
	$wpurl = site_url();
	$query_string = $_SERVER['QUERY_STRING'];
	$query_string = str_replace('&order_by_dir=desc', '', $query_string);
	$query_string = str_replace('&order_by_dir=asc', '', $query_string);
	$query_string = str_replace('&order_by=_price_value', '', $query_string);
	$query_string = str_replace('&order_by=_mileage_value', '', $query_string);
	$wpurl_img = $wpurl.'/wp-content/plugins/car-demon/theme-files/images/';
	if ($page_type == 'search') {
		$wpurl = $wpurl .'?'. $query_string;
	} else {
		$wpurl = '?'. $query_string;
	}
	$car_demon_sorting = '';
	$do_sort = 1;
	$sort_price = 1;
	$sort_miles = 1;
	if (isset($car_demon_options['do_sort'])) {
		if ($car_demon_options['do_sort'] == 'No') {
			$do_sort = 0;
		}
	}
	if ($do_sort == 1) {
		$car_demon_sorting = __('Sort By:', 'car-demon');
		if (isset($car_demon_options['sort_price'])) {
			if ($car_demon_options['sort_price'] == 'No') {
				$sort_price = 0;
			}
		}
		if ($sort_price == 1) {
			$sort_asc_img = '<a href="'.$wpurl.'&order_by=_price_value&order_by_dir=asc"><img src="'.$wpurl_img.'sort_asc.png" title="'.__('Sort Low to High', 'car-demon').'" /></a>&nbsp;';
			$sort_desc_img = '<a href="'.$wpurl.'&order_by=_price_value&order_by_dir=desc"><img src="'.$wpurl_img.'sort_desc.png" title="'.__('Sort High to Low', 'car-demon').'" /></a>';
			$car_demon_sorting .= '&nbsp;&nbsp;&nbsp;'.__('Price', 'car-demon').' '.$sort_asc_img.$sort_desc_img;
		}
		if (isset($car_demon_options['sort_miles'])) {
			if ($car_demon_options['sort_miles'] == 'No') {
				$sort_miles = 0;
			}
		}
		if ($sort_miles == 1) {
			$sort_asc_img = '<a href="'.$wpurl.'&order_by=_mileage_value&order_by_dir=asc"><img src="'.$wpurl_img.'sort_asc.png" title="'.__('Sort Low to High', 'car-demon').'" /></a>&nbsp;';
			$sort_desc_img = '<a href="'.$wpurl.'&order_by=_mileage_value&order_by_dir=desc"><img src="'.$wpurl_img.'sort_desc.png" title="'.__('Sort High to Low', 'car-demon').'" /></a>';
				$car_demon_sorting .= '&nbsp;&nbsp;&nbsp;'.__('Mileage', 'car-demon').' '.$sort_asc_img.$sort_desc_img;
		}
	}
	if (isset($car_demon_options['drop_down_sort'])) {
		if ($car_demon_options['drop_down_sort'] == 'Yes') {
			if (isset($_GET['order_by'])) {
				if ($_GET['order_by'] == '_mileage_value') {
					$select_price = '';
					$select_mileage = ' selected';
				} else {
					$select_price = ' selected';
					$select_mileage = '';
				}
			} else {
				$select_price = ' selected';
				$select_mileage = '';
			}
			if (isset($_GET['order_by_dir'])) {
				if ($_GET['order_by_dir'] == 'asc') {
					$select_desc = '';
					$select_asc = ' selected';
				} else {
					$select_desc = ' selected';
					$select_asc = '';	
				}
			} else {
				$select_desc = ' selected';
				$select_asc = '';	
			}
			parse_str($query_string, $output);
			$hidden_items = '';
			foreach ( $output as $key => $value ) {
				if (!empty($value)) {
					$hidden_items .= '<input type="hidden" value="'.$value.'" name="'.$key.'" />';
				}
			}

			$car_demon_sorting = '<form id="frm_cd_sort" name="frm_cd_sort" action="" method="get">
						'.$hidden_items.'
						<span id="cd_sort_by_label" class="cd_sort_by_label">'.__('Sort By: ','car-demon').'</span>
						<select id="order_by" name="order_by" class="cd_order_by" onchange="document.forms[\'frm_cd_sort\'].submit();">
							';
							if (isset($car_demon_options['sort_price'])) {
								if ($car_demon_options['sort_price'] != 'No') {
									$car_demon_sorting .= '<option value="_price_value"'.$select_price.'>'.__('Price', 'car-demon').'</option>';
								}
							}

							if (isset($car_demon_options['sort_miles'])) {
								if ($car_demon_options['sort_miles'] != 'No') {
									$car_demon_sorting .= '<option value="_mileage_value"'.$select_mileage.'>'.__('Mileage', 'car-demon').'</option>';
								}
							}
						$car_demon_sorting .= '</select>';

			$car_demon_sorting .= '&nbsp;<select id="order_by_dir" name="order_by_dir" class="cd_order_by_dir" onchange="document.forms[\'frm_cd_sort\'].submit();">
										<option value="desc"'.$select_desc.'>'.__('Desc', 'car-demon').'</option>
										<option value="asc"'.$select_asc.'>'.__('Asc', 'car-demon').'</option>
									</select></form>';
		}
	}
	$car_demon_sorting = apply_filters('car_demon_sort_filter', $car_demon_sorting );
	return $car_demon_sorting;
}
function car_demon_filter_search_title($title) {
	$title = str_replace('Page not found','Search Results', $title);
	return $title;
}
?>