<?php
if ( !is_admin() ) {
	add_action( 'wp', 'start_car_demon' );
	add_filter( 'widget_text', 'car_demon_text_filter', 11 );
	add_filter( 'the_content', 'car_demon_text_filter', 11 );
}

function start_car_demon() {
	if (!session_id()) {
		session_start();
	}
	if (isset($_GET['sales_code'])) {
		$sales_code = $_GET['sales_code'];
	} else {
		$sales_code = '';
	}
	if ($sales_code=="0") {
		setcookie('sales_code',$sales_code, time()-3600*24*90, '/');
		$redirect = car_demon_self_url();
		$redirect = str_replace('?sales_code='.$sales_code, '', $redirect);
		$redirect = str_replace('&sales_code='.$sales_code, '', $redirect);
		if (empty($redirect)) { $redirect = site_url(); }
		header('Location:'.$redirect);
	}
	if (!empty($sales_code)) {
		setcookie('sales_code',$_GET['sales_code'], time()+3600*24*90, '/');
		$redirect = car_demon_self_url();
		$redirect = str_replace('?sales_code='.$sales_code, '', $redirect);
		$redirect = str_replace('&sales_code='.$sales_code, '', $redirect);
		if (empty($redirect)) { $redirect = site_url(); }
		header('Location:'.$redirect);
	}
	car_demon_subdomains();
}

add_action( 'init', 'car_demon_init' );
function car_demon_init() {
	load_plugin_textdomain( 'car-demon', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' );
	if (!is_admin()) {
		wp_enqueue_script('jquery');
	}
}

// Add support for Featured Images
if (function_exists('add_theme_support')) {
    add_theme_support('post-thumbnails');
    add_image_size('index-categories', 150, 150, true);
    add_image_size('page-single', 350, 350, true);
}

add_action( 'init', 'car_demon_session', 1 );
function car_demon_session() {
	global $car_demon_options;
	$car_demon_options = car_demon_options();

	if (isset($car_demon_options['search_form_count'])) {
		if ($car_demon_options['search_form_count'] == 'Yes') {
			define('CD_NO_SEARCH_FORM_COUNT', true);
		}
	}
	
	if (!session_id()) {
		session_start();
	}
	if (isset($car_demon_options['use_session'])) {
		if (isset($car_demon_options['use_session']) == 'Yes') {
			$_SESSION['car_demon_options'] = $car_demon_options;
		}
	}
	//--Register Mobile Widget Areas
	if ($car_demon_options['mobile_theme'] == 'Yes') {
		car_demon_register_mobile_sidebars();
	}
}

add_action( 'init', 'register_car_demon_menus' );
function register_car_demon_menus(){
	global $car_demon_options;
	if ($car_demon_options['mobile_theme'] == 'Yes') {
		register_nav_menus(
			array(
				'mobile-menu' => __( 'Mobile Menu','car-demon' )
			)	
		);
		register_nav_menus(
			array(
				'top-mobile-menu' => __( 'Top Mobile Menu','car-demon' )
			)	
		);
	}
}

if ( function_exists('register_sidebar') ){
	add_action( 'widgets_init', 'car_demon_register_sidebars', 2 );
}

function car_demon_text_filter( $body ) {
	$text = replace_contact_info_tags( 0, $body );
	return $text;
}

function car_demon_self_url() {
    if(!isset($_SERVER['REQUEST_URI'])){
        $serverrequri = $_SERVER['PHP_SELF'];
    } else {
        $serverrequri = $_SERVER['REQUEST_URI'];
    }
    $s = empty($_SERVER["HTTPS"]) ? '' : ($_SERVER["HTTPS"] == "on") ? "s" : "";
    $protocol = car_demon_str_left(strtolower($_SERVER["SERVER_PROTOCOL"]), "/").$s;
    $port = ($_SERVER["SERVER_PORT"] == "80") ? "" : (":".$_SERVER["SERVER_PORT"]);

    return $protocol."://".$_SERVER['SERVER_NAME'].$port.$serverrequri;   
}

function car_demon_str_left( $s1, $s2 ) {
	return substr($s1, 0, strpos($s1, $s2));
}

function car_demon_subdomains() {
	if (empty($_COOKIE['domain_check'])) {
		$site_url = car_demon_get_site_url();
		setcookie("domain_check","1", time()+3600*24*90, '/', $site_url);
		if (empty($_COOKIE['sales_code'])) {
			$this_url = $_SERVER['SERVER_NAME'];
			$this_url = str_replace('www.', '', $this_url);
			$this_url = str_replace('http://', '', $this_url);
			$this_url = str_replace('https://', '', $this_url);
			$site_url =  car_demon_get_site_url();
			$site_url = str_replace('www.', '', $site_url);
			$site_url = str_replace('http://', '', $site_url);
			$site_url = str_replace('https://', '', $site_url);
			$site_url = 'check-'.$site_url;
			if (strpos($site_url, $this_url) == 0) {
				global $wpdb;
				$prefix = $wpdb->prefix;
				$sql = 'SELECT user_id from '.$prefix.'usermeta where meta_key="custom_url" AND meta_value like "%'.$this_url.'%"';
				$posts = $wpdb->get_results($sql);
				if ($posts) {
					foreach ($posts as $post) {
						$user_id = $post->user_id;
					}
					$site_url = str_replace('check-', '', $site_url);
					if (empty($redirect)) { $redirect = site_url().'?sales_code='.$user_id; }
					header('Location:'.$redirect);
				}
			}
		}
	}
}

function car_demon_get_site_url() {
	global $wpdb;
	$prefix = $wpdb->prefix;
	$sql = 'SELECT option_value from '.$prefix.'options WHERE option_name="siteurl"';
	$posts = $wpdb->get_results($sql);
	if ($posts) {
		foreach ($posts as $post) {
			$site_url = $post->option_value;
		}
	}
	return $site_url;
}

if ( !is_admin() ) add_filter( 'pre_get_posts', 'get_car_demon_posts' );
	function get_car_demon_posts( $query ) {
		if ( is_post_type_archive('cars_for_sale') || is_tax('vehicle_condition') || is_tax('vehicle_year') || is_tax('vehicle_make') || is_tax('vehicle_model') || is_tax('vehicle_body_style') ){
			if ($query->is_main_query()) {
				$query->set( 'post_type', array( 'cars_for_sale' ) );
				$query->set('posts_per_page', 9);
			}
		}
		return $query;
}

function rwh( $x,$y ) {
	if ($y == 0) {
		$new_string = $x;	
	} else {
		$new_string = '<h'.$y.'>'.$x.'</h'.$y.'>';
	}
	return $new_string;
}
?>